/***********************************************************************/
/*                                                                     */
/*  FILE        :LAN_Sample.c                                          */
/*  DATE        :Fri, Jul 30, 2010                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :SH72620                                               */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.16).    */
/*                                                                     */
/***********************************************************************/
                  
#include <machine.h>
#include <string.h>
#include "iodefine.h"
#include "sci2.h"
#include "socket.h"



#define	BUFSIZE		32			/* GR[obt@TCY	*/


void main(void);

void EnableNetInt( byte mask );
void DisableNetInt( byte mask );

void UDP_Echo(SOCKET);
void TCP_Echo(SOCKET);


/*
 	MACAhX
 {@pMACAhXȂ̂ŁAeŗpӂ̂gpĂ
*/
static byte	macAdrs[8] = { 0x00, 0x10, 0x47, 0xfe, 0x84, 0xfc };

extern info_t	socksts[MAX_SOCKET];	/* e\Pbg */



void main(void)
{
	set_imask( 15 );		// 荞݋֎~
	CPU_BusInitialize();
	SCI2_Initialize();

	CPU_IRQ3Initialize();

	SPI_Init();

	CMT0_Initialize();
	set_imask( 0 );			// Sx荞݋

	/* lbg[NANZX{ݒ	*/
	InitNetConf( macAdrs, mkAddr(192,168,0,103), mkAddr(255,255,255,0), mkAddr(192,168,0,1) );

	/* \Pbg	*/
	InitSocket( S0_MEM_2K|S1_MEM_2K|S2_MEM_2K|S3_MEM_2K, 
				S0_MEM_2K|S1_MEM_2K|S2_MEM_2K|S3_MEM_2K );	/*  */

	EnableNetInt( IR_SOCK(0)|IR_SOCK(1) );	/* 荞݂ŉ */

	/* UDPGR[T[oOpen	*/
	if( socket( SOCKET0, SOCK_DGRAM, 7, NO_OPTION ) != INVALID_SOCKET )
	{
		SCI2_Puts( "\nUDP ECHO SERVER OPEN" );		/* Open	*/
	}

	while(TRUE)
	{
		if( getSnSR( SOCKET1 ) == Sn_SR_CLOSED )	/* \PbgOPENĂȂ */
		{
			if( socket( SOCKET1, SOCK_STREAM, 7, NO_OPTION ) != INVALID_SOCKET )	/* I[v */
			{
				if( listen( SOCKET1 ) == 0 )		/* \PbgT[o */
				{
					SCI2_Puts( "\nTCP ECHO SERVER LISTEN" );	/* ҂Jn	*/
				}
			}
		}
	}
}

/*============================================================================*/
/*!	\brief		LAN_Interrupt()
	\param		Ȃ
	\retval		Ȃ
	\note		LAN 荞ݏ(IRQ3)
*//*==========================================================================*/
void LAN_Interrupt(void)
{
	byte 	ir = getNetInterrupt();	// 荞ݗv擾

	switch(ir)
	{
	case IR_SOCK(0):
		UDP_Echo( SOCKET0 );		// UDPGR[
		break;

	case IR_SOCK(1):
		TCP_Echo( SOCKET1 );		// TCPGR[
		break;

	default:
		clrNetInterrupt( ir );		// 荞ݗvNA
		break;
	}

	INTC.IRQRR.BIT.IRQ3F = 0;		// IRQ3荞݃NA 
}
/*============================================================================*/
/*!	\brief		UDP_Echo( SOCKET sn )
	\param		SOCKET	sn	\Pbgԍ
	\retval		Ȃ
	\note		UDPGR[T[o
*//*==========================================================================*/
void UDP_Echo( SOCKET sn )
{
	byte 	snir = getSnIR( sn );	/* 荞ݗv擾 */

	if(snir & Sn_IR_RECV)			/* Mf[^̏ꍇ */
	{
		byte 	buf[BUFSIZE];
		dword	addr;
		word	port;
		int		len;

		len = recvfrom( sn, buf, BUFSIZE, &addr, &port );	/* f[^M */
		if( len != SOCKET_ERROR )
		{
			char	tmp[16];
			
			SCI2_PutLf();
			SCI2_Puts( inet_ntoa( addr, tmp ) );
			SCI2_Putch(':');
			SCI2_PutDecW(port);
			SCI2_Putch('(');
			SCI2_PutDec(len);
			SCI2_Puts(")=");
			SCI2_PutsL((char*)buf, len);
			
			sendto( sn, buf, len, addr, port );	/* GR[M */
		}
		setSnIR( sn, snir );	/* 荞ݗvNA */
	}
}
/*============================================================================*/
/*!	\brief		TCP_Echo( SOCKET sn )
	\param		SOCKET	sn	\Pbgԍ
	\retval		Ȃ
	\note		TCPGR[T[o[
*//*==========================================================================*/
void TCP_Echo( SOCKET sn )
{
	byte 	snir = getSnIR( sn );		/* 荞ݗv擾 */

	if( snir & Sn_IR_CON )				/* RlNVm */
	{
		char	tmp[16];

		SCI2_Puts( "\nCONNECT " );
		SCI2_Puts( inet_ntoa( getSnDestIp( sn ), tmp ) );

		setSnIR( sn, Sn_IR_CON );
	}
	if( snir & Sn_IR_RECV )				/* Mf[^̏ꍇ */
	{
		byte 	buf[BUFSIZE];
		int		len;

		setSnIR( sn, Sn_IR_RECV );
		len = recv( sn, buf, BUFSIZE );	/* f[^M */
		if( len != SOCKET_ERROR )
		{
			send( sn, buf, len );		/* GR[M */

			SCI2_Puts( "\nTCP(" );
			SCI2_PutDec( len );
			SCI2_Puts( ")=" );
			SCI2_PutsL( (char *)buf, len );
		}
	}
	if( snir & Sn_IR_DISCON )			/* RlNVN[Y	*/
	{
		SCI2_Puts( "\nDISCONNECT" );

		setSnIR( sn, Sn_IR_DISCON );
		closesocket( sn );
	}
}
/*============================================================================*/
/*!	\brief		EnableNetInt( byte mask )
	\param		byte mask	荞݋rbg(IR_SOCK(ch))
	\retval		Ȃ
	\note		lbg[N(IRQ3) 荞݋
*//*==========================================================================*/
void EnableNetInt( byte mask )
{
	setNetIntMask( getNetIntMask() | mask );	// 荞݋

	CPU_IRQ3Enable();
}	
/*============================================================================*/
/*!	\brief		DisableNetInt( byte mask )
	\param		byte mask	荞݋֎~rbg(IR_SOCK(ch))
	\retval		Ȃ
	\note		lbg[N(IRQ3) 荞݋֎~
*//*==========================================================================*/
void DisableNetInt( byte mask )
{
	byte new_mask = getNetIntMask() & ~mask;

	setNetIntMask( new_mask );	// 荞݋֎~

	if(!new_mask)	CPU_IRQ3Disable();	// 荞ݎgp
}	
