/*============================================================================*/
/*!	\file		spi.c
	\brief		SPIʐM	W5100
	\author		kuni
	\date		2010/07/31
	\version	1.0
*//*==========================================================================*/
#include	<machine.h>
#include	"iodefine.h"
#include	"spi.h"


static void SPI_Operation(void);

#define	DisableInterrupt()	(INTC.IPR01.BIT._IRQ3=0)	// IRQ3荞݋֎~
#define	EnableInterrupt()	(INTC.IPR01.BIT._IRQ3=15)	// IRQ3荞݋


/* ---------- W5100 SPIR}h ---------- */
#define	SPI_WRITE		0xf0
#define	SPI_READ		0x0f

/* ---------- W5100 }N ---------- */

/* SPIMobt@Zbg	*/
#define	SPI_BF_RESET()	{	RSPI0.SPBFCR.BYTE = 0xC0u;	/* Mobt@̃f[^Zbg */ \
							RSPI0.SPBFCR.BYTE = 0x00u;	/* Mobt@̃f[^Zbg */ }

/* SPIMobt@Zbg	*/
#define	SPI_BF_TXRESET() {	RSPI0.SPBFCR.BYTE = 0xC0u;	/* Mobt@̃f[^Zbg */ \
							RSPI0.SPBFCR.BIT.TXRST = 0;	/* Mobt@̂݃f[^Zbg */ }

/*============================================================================*/
/*!	\brief		void	SPI_Init( void )
	\param		Ȃ
	\retval		Ȃ
	\note		SPIANZX֘A
*//*==========================================================================*/
void SPI_Init(void)
{
	PORT.PFCR3.WORD  =  0x0003;	// PF12=MISO0
	PORT.PFCR2.WORD  =  0x3030;	// PF11=MOSI0  PF10(ROM_CS)  PF9=RSPCK0    PF8(LCD_SPICS)
	PORT.PFCR1.WORD  =  0x0022;	// PF7         PF6           PF5=SSIDATA2  PF4=SSIWS2
	PORT.PFCR0.WORD  =  0x2440;	// PF3=SSICK2  PF2=TxD2      PF1=RxD2      PF0
	PORT.PFDR0.WORD  |= 0x0500;	// PF10:ROM_CS='High'  PF8:LCD_SPICS='High'
	PORT.PFIOR0.WORD |= 0x0500;	// PF10:ROM_CS(output) PF8:LCD_SPICS(output)

	PORT.PGDR1.WORD  =  0x010;	// PG20:MMC_CS='High'
	PORT.PGIOR1.WORD |= 0x010;	// PG20:MMC_CS(output)	

	PORT.PJDR0.WORD  = 0x0008;	// PJ3:LAN_CS='High'
	PORT.PJIOR0.WORD = 0x0008;	// PJ3:LAN_CS(output), PJ1:MMC_CD(input)

	CPG.STBCR5.BIT.MSTP51 = 0;	// SPI CH0 NbN

	/* ==== RSPI ==== */
	RSPI0.SPCR.BYTE   =	0x08;	/* RSPI~ }X^[h(MSTR=1) MODFEN=0 */
	RSPI0.SSLP.BYTE   =	0x00;	/* SSLP=0:SSL signal 0-active */
	RSPI0.SPPCR.BYTE  =	0x00;	/* MOSIAChŒl = O]ŏIf[^ */
	RSPI0.SPBR.BYTE   = 0x05;	/* F48(B=72MHz) */
	RSPI0.SPDCR.BYTE  =	0x60;	/* TXDMY=0:_~[f[^M֎~ */
								/* SPLW=11:SPDR 32rbgANZX */
	RSPI0.SPCKD.BYTE  =	0x00;	/* RSPCKx      F1RSPCK */
	RSPI0.SSLND.BYTE  =	0x00;	/* SSLlQ[gxF1RSPCK */
	RSPI0.SPND.BYTE   =	0x00;	/* ANZXx F1RSPCK + 2 B */ 
	RSPI0.SPSCR.BYTE  =	0x00;	/* V[PX   F1(SPCMD0̂ݎgp) */
	RSPI0.SPCMD0.WORD = 0xe30c; /* LSBF=0:MSBt@[Xg 
								   SPB =0011:32bit
								   BRDV=11:8 
								   CPOL=0:
								   CPHA=0:GbWŃf[^Tv */
	SPI_BF_RESET();				/* Mobt@̃f[^Zbg */
}

/*============================================================================*/
/*!	\brief		void	SPI_Operation()
	\param		
	\retval		Ȃ
	\note		SPIʐM
	\warning	f[^WX^(SPDR)փR}hZbgČĂяo
*//*==========================================================================*/
static void SPI_Operation(void)
{
	byte	n;
	
	/* ---- SPI] ---- */
    PORT.PJDR0.BIT.PJ3DR = 0;	/* /LAN_CS AT[g f[^]Jn	*/
	RSPI0.SPCR.BIT.SPE = 1;		/* SPI]N	*/


	n = RSPI0.SPSR.BYTE;		/* ANZXEFCg	*/
		
	while( RSPI0.SPSR.BIT.TEND == 0 ) {	/* M҂ */
		/* wait */
	}	

	/* ---- SPI]IiSSLlQ[gj ---- */
	RSPI0.SPCR.BIT.SPE = 0;
    PORT.PJDR0.BIT.PJ3DR = 1;	/* /LAN_CS lQ[g f[^]I	*/
}

/* -------------------- {ǂݏ -------------------- */

/*============================================================================*/
/*!	\brief		void	w5100_write( word addr, byte data )
	\param		addr: WX^AhX
	\param		data: ݒl
	\retval		Ȃ
	\note		W5100WX^֏
*//*==========================================================================*/
void	w5100_write( word addr, byte data )
{
	us_t	t;
	ul_t	cmd;

	DisableInterrupt();				/* 荞݋֎~	*/

	/* ==== Mobt@̃f[^Zbg ==== */
	SPI_BF_TXRESET();

	t.data = addr;
	/* ==== MOSI(R}hAAhXACgf[^) ==== */
	cmd.bytes.hh = SPI_WRITE;		/* ݃R}h */
	cmd.bytes.hl = t.bytes.hi;		/* AhX	*/
	cmd.bytes.lh = t.bytes.lo;
	cmd.bytes.ll = data;			/* f[^	*/

	RSPI0.SPDR.LONG = cmd.data;		/* R}h */
    SPI_Operation();
	EnableInterrupt();				/* 荞݋ */
}

/*============================================================================*/
/*!	\brief		byte	w5100_read( word addr )
	\param		WX^AhX
	\retval		ǂݏof[^
	\note		W5100WX^l擾
*//*==========================================================================*/
byte	w5100_read( word addr )
{
	us_t	t;
	ul_t	cmd;
	byte 	dat;

	DisableInterrupt();				/* 荞݋֎~	*/

	/* ==== Mobt@̃f[^Zbg ==== */
	SPI_BF_RESET();

	t.data = addr;
	/* ==== MOSI(R}hAAhXA_~[f[^) ==== */
	cmd.bytes.hh = SPI_READ;   		/* ǂݏoR}h */
	cmd.bytes.hl = t.bytes.hi;		/* AhX	*/
	cmd.bytes.lh = t.bytes.lo;

	RSPI0.SPDR.LONG = cmd.data;		/* R}h */
    SPI_Operation();

	/* ---- MISO([hf[^) ---- */
	dat = RSPI0.SPDR.LONG;			/* Mf[^擾	*/
	EnableInterrupt();				/* 荞݋ */
	return dat;
}


/*============================================================================*/
/*!	\brief		void	w5100_writebuf( word addr, byte *buf, word len )
	\param		addr: AhX
	\param		buf: f[^obt@
	\param		len: ݒ
	\retval		Ȃ
	\note		W5100A
*//*==========================================================================*/
void	w5100_writebuf( word addr, byte *buf, word len )
{
	word	i;
	us_t	t;
	ul_t	cmd;

	DisableInterrupt();				/* 荞݋֎~	*/

	/* ==== Mobt@̃f[^Zbg ==== */
	SPI_BF_TXRESET();

	t.data = addr;
	cmd.bytes.hh = SPI_WRITE;   	/* ݃R}h */

	for( i = 0; i<len; i++, t.data++ )
	{
		/* ==== MOSI(R}hAAhXACgf[^) ==== */
		cmd.bytes.hl = t.bytes.hi;	/* AhX	*/
		cmd.bytes.lh = t.bytes.lo;
		cmd.bytes.ll = *buf ++;		/* f[^	*/

		RSPI0.SPDR.LONG = cmd.data;		/* R}h */
		SPI_Operation();
	}
	EnableInterrupt();			/* 荞݋ */
}


/*============================================================================*/
/*!	\brief		void	w5100_readbuf( word addr, byte *buf, word len )
	\param		addr: AhX
	\param		buf: Mf[^i[obt@
	\param		len: ǂݍݒ
	\retval		Ȃ
	\note		W5100Aǂݍ
*//*==========================================================================*/
void	w5100_readbuf( word addr, byte *buf, word len )
{
	word	i;
	us_t	t;
	ul_t 	cmd;

	DisableInterrupt();			/* 荞݋֎~	*/

	/* ==== Mobt@̃f[^Zbg ==== */
	SPI_BF_RESET();

	t.data = addr;
	cmd.bytes.hh = SPI_READ;   			/* ǂݏoR}h */

	for( i = 0; i < len; i++, t.data++ )
	{
		/* ==== MOSI(R}hAAhXACgf[^) ==== */
		cmd.bytes.hl = t.bytes.hi;		/* AhX	*/
		cmd.bytes.lh = t.bytes.lo;

		RSPI0.SPDR.LONG = cmd.data;		/* R}h */
		SPI_Operation();

		/* ---- MISO([hf[^) ---- */
		*buf ++ = (byte)RSPI0.SPDR.LONG;	/* Mf[^i[	*/
	}
	EnableInterrupt();			/* 荞݋ */
}

